App::Cmd::Command::help(3pm)

NAME
App::Cmd::Command::help - display a command's help screen

VERSION
version 0.340

DESCRIPTION
This command will either list all of the application commands and their abstracts, or display the usage screen for a subcommand with its description.

PERL VERSION
This library should run on perls released even a long time ago. It should work on any version of perl released in the last five years.

Although it may work on older versions of perl, no guarantee is made that the minimum required version will not be increased. The version may be increased for any reason, and there is no promise that patches will be accepted to lower the minimum required perl.

USAGE
The help text is generated from three sources:

•   The "usage_desc" method

•   The "description" method

•   The "opt_spec" data structure

The "usage_desc" method provides the opening usage line, following the specification described in Getopt::Long::Descriptive. In some cases, the default "usage_desc" in App::Cmd::Command may be sufficient and you will only need to override it to provide additional command line usage information.

The "opt_spec" data structure is used with Getopt::Long::Descriptive to generate the description of the options.

Subcommand classes should override the "discription" method to provide additional information that is prepended before the option descriptions.

For example, consider the following subcommand module:

  package YourApp::Command::initialize;

  # This is the default from App::Cmd::Command
  sub usage_desc {
    my ($self) = @_;
    my $desc = $self->SUPER::usage_desc; # "%c COMMAND %o"
    return "$desc [DIRECTORY]";
  }

  sub description {
    return "The initialize command prepares the application...";
  }

  sub opt_spec {
    return (
      [ "skip-refs|R",  "skip reference checks during init", ],
      [ "values|v=s@",  "starting values", { default => [ 0, 1, 3 ] } ],
    );
  }

  ...

That module would generate help output like this:

  $ yourapp help initialize
  yourapp initialize [-Rv] [long options...] [DIRECTORY]

  The initialize command prepares the application...

        --help            This usage screen
        -R --skip-refs    skip reference checks during init
        -v --values       starting values

AUTHOR
Ricardo Signes <cpan@semiotic.systems>

COPYRIGHT AND LICENSE
This software is copyright (c) 2026 by Ricardo Signes.

This is free software; you can redistribute it and/or modify it under the same terms as the Perl 5 programming language system itself.